

void draw_screen( PLAYER *peep ) {
int             draw_ball_x,
                draw_ball_y,
                ball_distance,
                ball_distance_multiplier,
                count;
PIN             *tmp;
PLAYER          *play;

clear_to_color( buff, 0 );

blit( lane, buff, 0, 0, 0, 0, 320, 200 );

ball_distance_multiplier = ball.y * .005 * polarity( ball.x );

draw_ball_x = 160 + ( ( ball.x - 500 ) * ( 1.15 * ball.y * .001 + 1 ) ) / 20;
draw_ball_y = 80 + ball.y / 20;
ball_distance = 4 + ( ball.y * .005 );

if( ball.x <= 0 || ball.x >= 1000 ) {
   draw_ball_y += ( ball_distance * 2 ) / 3;
   }


if( ball.y < 20 ) {
   circlefill( buff, draw_ball_x, draw_ball_y - ball_distance, ball_distance, 96 );
   }

tmp = pins->next;

while( tmp != NULL ) {
   if( !tmp->fall ) {
      draw_sprite( buff, pin, 160 + ( ( tmp->x - 500 ) / 20 ) - 4, 80 + tmp->y / 20 - 16 );
      }
   else if( polarity( tmp->acc[X] ) * tmp->acc[X] > .25 ) {
      rotate_sprite( buff, pin, 160 + ( ( tmp->x - 500 ) / 20 ) - 4, 80 + tmp->y / 20 - 16, itofix( 32 * ( ( tmp->frame % 8 ) + 4 ) ) );
      }
   else {
      rotate_sprite( buff, pin, 160 + ( ( tmp->x - 500 ) / 20 ) - 8, 80 + tmp->y / 20 - 10, itofix( 64 ) );
      }

   if( tmp->y / 2 < 60 ) {
      if( !tmp->fall )
         circlefill( buff, 243 + tmp->x / 20, 60 + tmp->y / 2, 3, 64 );
      else 
         circlefill( buff, 243 + tmp->x / 20, 60 + tmp->y / 2, 3, 16 );
      }

   tmp = tmp->next;
   }

if( mouse_b & 1 ) {
   line( buff, 160 + ( ( ball.x - 500 ) * ( 1.25 * ball.y * .001 + 1 ) ) / 20,
         80 + ball.y / 20, 160 + ( ( ball.x - 500 ) * ( 1.25 * ( ball.y - 600 ) * .001 + 1 ) ) / 20,
         80 + ( ball.y - 600 ) / 20, 0 );
   }

if( ball.y >= 20 ) {
   circlefill( buff, draw_ball_x, draw_ball_y - ball_distance, ball_distance, 96 );
   }

textprintf( buff, font, 2, 2, 255, "%s: %i", peep->name, peep->total_score );

if( frame > 0 ) {
   textprintf( buff, font, 30, 22, 255, "%i", frame );
   textprintf( buff, font, 20, 32, 255, "[%i|%i]", peep->score_sheet[0][frame - 1],
               peep->score_sheet[1][frame - 1] );
   }
textprintf( buff, font, 80, 22, 255, "%i", frame + 1 );
textprintf( buff, font, 70, 32, 255, "[%i|%i]", peep->score_sheet[0][frame],
            peep->score_sheet[1][frame] );


textprintf( buff, font, 300 - text_length( font, "Frame:" ), 2, 255, "Frame:" );
textprintf( buff, font, 300 - text_length( font, "00" ), 12, 255, "%i", frame + 1 );

if( game_flags & BUMPERS ) {
   textprintf( buff, font, 300 - text_length( font, "Bumpers Up" ), 190, 255, "Bumpers Up" );
   }

play = players->next;
count = 0;

while( play != NULL ) {

    rectfill( buff, 4, 50 + count * 12, 110, 50 + ( count + 1 ) * 12, 0 );
    rect( buff, 4, 50 + count * 12, 110, 50 + ( count + 1 ) * 12, 255 );
    /* Ugliest Line of code, ever... */
    textprintf( buff, font, 6, 52 + count * 12, 255, "%c%c%c%c%c%c%c%c%c", play->name[0],
                play->name[1], play->name[2], play->name[3], play->name[4],
                play->name[5], play->name[6], play->name[7], play->name[8] );
    textprintf( buff, font, 110 - text_length( font, "000" ), 52 + count * 12, 255, "%i", play->total_score );

    count++;
    play = play->next;
    }

blit( buff, screen, 0, 0, 0, 0, 320, 200 );


}



int display_scores( void ) {
PLAYER   *tmp;
BITMAP   *t;
int      z;
MIDI     *finale;

if( !( game_flags & NO_MUSIC ) )
   if( ( finale = load_midi( "finale.mid" ) ) != NULL )
      play_midi( finale, 1 );


t = create_bitmap( 320, 200 );

rectfill( buff, 20, 40, 300, 140, 0 );
rect( buff, 20, 40, 300, 140, 255 );

tmp = players->next;
z = 0;

while( tmp != NULL ) {
   textprintf( buff, font, 40, 50 + 10 * z, 255, "%s", tmp->name );
   textprintf( buff, font, 250, 50 + 10 * z++, 255, "%i", tmp->total_score );
   tmp = tmp->next;
   }

rectfill( buff, 80, 145, 240, 180, 0 );
rect( buff, 80, 145, 240, 180, 255 );
rectfill( buff, 90, 165, 140, 175, 0 );
rect( buff, 90, 165, 140, 175, 255 );
textprintf_centre( buff, font, 115, 166, 255, "Yes" );
rectfill( buff, 180, 165, 230, 175, 0 );
rect( buff, 180, 165, 230, 175, 255 );
textprintf_centre( buff, font, 205, 166, 255, "No" );
textprintf_centre( buff, font, 160, 147, 255, "Play Another?" );

while( 1 ) {
   clear_to_color( t, 0 );

   blit( buff, t, 0, 0, 0, 0, 320, 200 );
   draw_sprite( t, pen, mouse_x, mouse_y );
   blit( t, screen, 0, 0, 0, 0, 320, 200 );

   if( mouse_x >= 90 && mouse_x <= 140 &&
       mouse_y >= 165 && mouse_y <= 175 &&
       mouse_b & 1 ) {
      show_mouse( NULL );
      return 1;
      }
   else if( mouse_x >= 180 && mouse_x <= 230 &&
       mouse_y >= 165 && mouse_y <= 175 &&
       mouse_b & 1 ) {
      show_mouse( NULL );
      return 0;
      }
   }
}




void display_good_throw( PLAYER *peep, int type ) {
BITMAP          *tmp;
int             blink = 4;

clear_to_color( buff, 0 );

tmp = create_bitmap( 8, 8 );
clear_to_color( tmp, 0 );

if( type == 1 ) {
   textprintf( tmp, font, 0, 0, 255, "X" );
   }
else {
   textprintf( tmp, font, 0, 0, 255, "/" );
   }

stretch_sprite( buff, tmp, 70, 15, 180, 180 );

textprintf_centre( buff, font, 160, 5, 255, "%s", peep->name );

while( blink-- > 0 ) {
   blit( buff, screen, 0, 0, 0, 0, 320, 200 );
   rest( 500 );
   clear_to_color( screen, 0 );
   rest( 500 );
   }

}

