#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>
#include <string.h>

#include "init.c"
#include "draw.c"
#include "physics.c"



int main( int argc, char *argv[] ) {
   PLAYER          *tmp;
   
   
   check_params( argc, argv );
   
   if( game_flags & NO_MUSIC ) {
      printf( "Music is OFF.\n" );
      }
   if( game_flags & NO_SOUND ) {
      printf( "Sound Effects are OFF.\n" );
      }
   if( game_flags & BUMPERS ) {
      printf( "Bumpers are ON.\n" );
      }
   if( game_flags & CRAZY_COLORS ) {
      printf( "Whoa dude! Totally Awesome!\n" );
      }
   if( game_flags & SKIP_GAME ) {
      printf( "Skipping to tenth frame...\n" );
      }
   if( game_flags ) {
      printf( "\n" );
      }
   
   new_player( );
   
   init( );

   if( music == NULL && !( game_flags & NO_MUSIC ) )
      if( ( music = load_midi( "music.mid" ) ) == NULL )
         printf( "MIDI file 'music.mid' does not exist or is corrupted.\n" );   

   
   do {
      int          z;
   
      play_midi( NULL, 0 );
      play_midi( music, 1 );
   

      tmp = players->next;
      while( tmp != NULL ) {
         tmp->total_score = 0;
         tmp->handicap = 0;
    
         for( z = 0; z < 11; z++ ) {
            tmp->score_sheet[0][z] = 0;
            tmp->score_sheet[1][z] = 0;
            }
         tmp = tmp->next;
         }

      for( frame = 0; frame < 10; frame++ ) {

         if( ( game_flags & SKIP_GAME ) )
            frame = 9;

         tmp = players->next;
         while( tmp != NULL ) {

            reset_pins( );

            roll = 0;
            prepare_roll( );
            player_turn( tmp );

            clear_pins( tmp );

            // If all pins are knocked down, advance turn and celebrate.
            if( pins->next == NULL ) {
               display_good_throw( tmp, 1 );

               // If it is 10th frame, reset pins for second throw.
               if( frame == 9 ) {
                  reset_pins( );
         
                  roll = 0;
                  prepare_roll( );
                  player_turn( tmp );
         
                  clear_pins( tmp );

                  // If another strike, reset pins for final throw.
                  if( pins->next == NULL ) {
                     display_good_throw( tmp, 1 );
      
                     reset_pins( );
            
                     roll = 0;
                     prepare_roll( );
                     player_turn( tmp );
            
                     clear_pins( tmp );
                     }  
                  }
               }                                                  

            // Second roll for all frames.
            else {
               roll = 1;
               prepare_roll( );
               player_turn( tmp );
               clear_pins( tmp );
               if( pins->next == NULL ) {
                  display_good_throw( tmp, 0 );

                  if( frame == 9 ) {
                     reset_pins( );
            
                     roll = 0;
                     prepare_roll( );
                     player_turn( tmp );
            
                     clear_pins( tmp );

                     if( pins->next == NULL ) 
                        display_good_throw( tmp, 1 );

                     }
                  }
               }



            update_scorecard( tmp );
 
            tmp = tmp->next;
            }
         }
   
   
      
      } while( display_scores( ) );
   
   
   remove_mouse( );
   
   return 0;
}
