int             pin_loc[20] = { 500, 100,
                                350, 80,
                                650, 80,
                                250, 60,
                                500, 60,
                                750, 60,
                                200, 40,
                                400, 40,
                                600, 40,
                                800, 40 };


void reset_pins( void ) {
PIN             *tmp;
int             z;

pins = NULL;
pins->next = NULL;

for( z = 0; z < 10; z++ ) {

   tmp = (PIN *)malloc( sizeof( PIN ) );

   tmp->x = pin_loc[z * 2];
   tmp->y = pin_loc[z * 2 + 1];
   tmp->frame = 0;
   tmp->fall = 0;

   tmp->next = pins->next;
   pins->next = tmp;

   }
}


void clear_pins( PLAYER *peep ) {
PIN             *tmp;


for( tmp = pins; tmp->next != NULL;  ) {

   if( tmp->next->fall == 1 ) {
      PIN       *z;

      z = tmp->next;
      tmp->next = tmp->next->next;
      free( z );
      peep->total_score++;
      peep->score_sheet[roll][frame]++;
      }
   else {
      tmp = tmp->next;
      }
   }

}



void pin_collision( void ) {
PIN             *tmp,
                *list;



tmp = pins->next;

while( tmp != NULL ) {

   if( tmp->fall ) {
      tmp->frame -= tmp->acc[X] * .5;
      }
   /* Ball colliding with pins */
   if( sqrt( SQUARE( ball.x - tmp->x ) + SQUARE( ball.y - tmp->y ) ) < 115 &&
       !tmp->fall ) {
      tmp->fall = 1;
      tmp->frame = 20 + rand()%10 * 4;

      tmp->acc[X] = ( tmp->x - ball.x ) * ball.acc[Y] * .015;
      tmp->acc[Y] = ball.acc[Y];
      if( !( game_flags & NO_SOUND ) ) {
         play_sample( pin_fall, 255, 0, 1000, 0 );
         }
      }

   /* Pins colliding with each other */
   if( tmp->fall && tmp->acc[X] * polarity( tmp->acc[X] ) > 4 ) {
      list = pins->next;
      while( list != NULL ) {
         if( sqrt( SQUARE( list->x - tmp->x ) + SQUARE( list->y - tmp->y ) ) < 40 && !list->fall ) {
            list->fall = 1;
            list->frame = 20 + rand()%10 * 4;

            list->acc[X] = ( list->x - tmp->x ) * tmp->acc[Y] * .005;
            list->acc[Y] = tmp->acc[Y] * .85;
            if( !( game_flags & NO_SOUND ) ) {
               play_sample( pin_fall, 255, 0, 1000, 0 );
               }
            }
         list = list->next;
         }
      }

   if( tmp->fall ) {
      if( tmp->x + tmp->acc[X] > 0 && tmp->x + tmp->acc[X] < 1000 &&
          tmp->acc[X] * polarity( tmp->acc[X] ) > 8 ) {
         tmp->x += tmp->acc[X];
         }
      if( tmp->y - tmp->acc[Y] > -10 ) {
         tmp->y -= tmp->acc[Y];
         }
      if( tmp->x + tmp->acc[X] < 0 && tmp->x + tmp->acc[X] > 1000 ) {
         tmp->acc[X] -= tmp->acc[X] * .25;
         tmp->acc[X] = 0 - tmp->acc[X];
         }
      if( tmp->y - tmp->acc[Y] < -10 ) {
         tmp->acc[Y] -= tmp->acc[Y] * .85;
         tmp->acc[Y] = 0 - tmp->acc[Y];
         }

      tmp->acc[X] -= tmp->acc[X] * .1;
      tmp->acc[Y] -= tmp->acc[Y] * .1;
      }


   tmp = tmp->next;
   }

}


void prepare_roll( void ) {

ball.x = 490;
ball.y = 2300;

ball.curve = 0.0;
ball.potential = 0.0;

ball.acc[X] = 0.0;
ball.acc[Y] = 0.0;
ball.move[X] = 0;
ball.move[Y] = 0;
       
}


int back_roll( void ) {
int             mx,
                my;


get_mouse_mickeys( &mx, &my );

if( !( mouse_b & 1 ) ) {
   ball.curve += mx * .1;
   ball.potential += mx * .0008;
   ball.acc[Y] += my * .05;
   }
else if( mouse_b & 1 && ball.x + mx > 0 && ball.x + mx < 1000 ) {
   ball.x += mx * 4;
   }

if( my < 0 && !( mouse_b & 1 ) ) {
   return 0;
   }
else {
   return 1;
   }
}



int fore_roll( void ) {
int             mx,
                my;


get_mouse_mickeys( &mx, &my );

ball.acc[X] += mx * .1;

if( ball.acc[Y] - my * .13 > -50 ) {
   ball.acc[Y] -= my * .13;
   }

if( my > 0 ) {
   return 0;
   }
else {
   return 1;
   }
}





/* Create PLAYER struct to pass here for each player's turn */

void player_turn( PLAYER *peep ) {
int             roll_stage = 100;



while( back_roll( ) ) {
   draw_screen( peep );
   if( key[KEY_ESC] ) exit( 0 );
   }

while( fore_roll( ) ) {
   draw_screen( peep );
   if( key[KEY_ESC] ) exit( 0 );
   }

if( ball.acc[Y] < 5 ) {
   rectfill( screen, 100, 120, 220, 160, 0 );
   rect( screen, 100, 120, 220, 160, 255 );

   textprintf_centre( screen, font, 160, 135, 255, "Try Again!" );
   readkey( );
   prepare_roll( );
   player_turn( peep );
   return;
   }

while( ball.y > -10 ) {

   ball.x += ball.acc[X];
   ball.y -= ball.acc[Y];

   (float)ball.x += ball.curve;

   if( game_flags & BUMPERS ) {

      if( ball.x - 95 <= 0 ) {
         ball.x = 95;
         ball.acc[X] = 0 - ball.acc[X];
         ball.curve = 0 - ball.curve;
         }
      else if( ball.x + 95 >= 1000 ) {
         ball.x = 905;
         ball.acc[X] = 0 - ball.acc[X];
         ball.curve = 0 - ball.curve;
         }
      }

   else if( ball.x <= 0 || ball.x >= 1000 ) {
      if( ball.x <= 0 )
         ball.x = 0;
      else if( ball.x >= 1000 )
         ball.x = 1000;

      if( !( game_flags & NO_SOUND ) ) {
         play_sample( gutter, 255, 0, 1000, 0 );
         }
      ball.acc[X] = 0;
      ball.curve = 0;
      }

   if( ball.curve < .5 && ball.curve > 0 ) {
      ball.curve = -.51;
      }
   else if( ball.curve > -.5 && ball.curve < 0 ) {
      ball.curve = .51;
      }

   if( ball.curve > 0 ) {
      ball.curve -= ball.curve * ball.potential;
      }
   else if( ball.curve > -100 ) {
      ball.curve += ball.curve * ball.potential;
      }

   pin_collision( );

   draw_screen( peep );
   if( key[KEY_ESC] ) exit( 0 );

   if( ball.y > 2500 ) {
      break;
      }

   rest( 25 );
   }

/* Pins settling */
while( roll_stage-- > 0 ) {
   pin_collision( );
   draw_screen( peep );
   if( key[KEY_ESC] ) exit( 0 );
   }

/* Ball Return */
ball.x = -200;
ball.y = 0;

while( ( ball.y += 4 ) < 1900 ) {
   pin_collision( );
   draw_screen( peep );
   if( key[KEY_ESC] ) exit( 0 );
   }



}


void update_scorecard( PLAYER *peep ) {

if( frame > 0 ) {
   /* Strike */
   if( peep->score_sheet[0][frame - 1] == 10 ) {
      peep->total_score += 10;
      peep->total_score += peep->score_sheet[0][frame] + 10;
      }
   /* Spare */
   else if( peep->score_sheet[0][frame - 1] + peep->score_sheet[1][frame - 1] == 10 ) {
      peep->total_score += peep->score_sheet[0][frame];
      }
   }
}
